import pytest

from peewee import IntegrityError

from endpoints.test.fixtures import database_uri, init_db_path, sqlitedb_file
from data.model.repository import create_repository

def test_duplicate_repository_different_kinds(database_uri):
  # Create an image repo.
  create_repository('devtable', 'somenewrepo', None, repo_kind='image')

  # Try to create an app repo with the same name, which should fail.
  with pytest.raises(IntegrityError):
    create_repository('devtable', 'somenewrepo', None, repo_kind='application')
